Unfortunately, this feature is not supported on mobile devices. For the best experience, please use a computer.

project44 REST API (4.0.0)

Version 4.0.0 of project44's API. If you're not familiar with project44, we recommend checking out our guides first: https://developers.project44.com/guides/shippers and https://developers.project44.com/guides/carriers.

Download OpenAPI description
Languages
Servers
NA - Endpoint for project44 tenants created in the NA region
https://na12.api.project44.com/
EU - Endpoint for project44 tenants created in the EU region
https://eu12.api.project44.com/
Sandbox - Endpoint for project44 tenants created in the sandbox environment
https://na12.api.sandbox.p-44.com/

OAuth 2.0: Client Applications

API used for registering and managing OAuth 2.0 client applications. See the "Authentication" section above for more information. To authorize API requests to project44 for an API integration, first your client application must be registered with project44, which will issue your application a client id and secret. These credentials can then be used to generate bearer tokens, which can be included on all other API requests to authorize your client application. The client application is authorized through the project44 user management UI as a machine user with username "app-{client_id}@client-applications.project44.com".

An admin user (with Movement user role "Customer Admin") must use HTTP Basic Authentication with this API to manage client applications. Basic Authentication is deprecated for all other APIs, besides token generation, in favor of passing the access token generated via OAuth 2.0.

Operations

OAuth 2.0: Token Generation

API for OAuth 2.0 token generation. See the "Authentication" section above for more information. Once your client application is registered, you can use the token generation endpoint to authenticate with your application's client id and secret in exchange for a bearer token to be included on all other API requests to authenticate as that client application. The client application is authorized through the project44 user management UI as a machine user with username "app-{client_id}@client-applications.project44.com".

To generate an access token, you may authenticate your client application by providing its client id and secret either in the body of the request or in the form of HTTP Basic Authentication (but you may not use both ways in the same request).

Operations

Shipment: Tracking

...

Operations

Filter Suggestions

...

Operations

Shipment Attributes

...

Operations

Shipment: Loads

...

Operations

Order Visibility

...

Operations

LTL: Quotes

...

Operations

LTL: Dispatch

...

Operations

LTL: Image Retrieval

...

Operations

LTL: Electronic BOL

API used for creating Electronic BOL

Operations

VLTL: Quotes

...

Operations

VLTL: Dispatch

...

Operations

TL: Available Vehicles

...

Operations

TL: Connected Capacity

...

Operations

Asset Tracking

...

Operations

Multi-Modal: Image Retrieval

...

Operations

Multi-Modal: Rating

API used for multi-modal Rating.

Operations

Multi-Modal: Booking

API used for multi-modal Booking.

Operations

Multi-Modal: Packaging

API used for managing packages for shipment planning.

Operations

Multi-Modal: Document

...

Operations

Webhook

...

Operations

Retrieve all push configurations.

Request

Retrieve all push configurations for a tenant and user.

curl -i -X GET \
  https://na12.api.project44.com/api/v4/webhooks \
  -H 'Authorization: Bearer <YOUR_TOKEN_HERE>'

Responses

OK

Body
webhookEndpointsArray of objects(WebhookEndpoint)

A list of webhook endpoints.

Response
{ "webhookEndpoints": [ {} ] }

Create or update a push configuration.

Request

Create or update a single push configuration. A maximum of 50 push configurations may be saved per tenant.

Bodyrequired

webhookEndpoint

authParamsobject

(Deprecated) The webhookAuthenticationMethod parameters. The subordinate fields for the 'authParams' field depend on the authType. This field is functional but is deprecated - authentication for new webhooks should be supplied in the 'authenticationMethods' field.

authTypestring

(Deprecated) The webhookAuthenticationMethod type. BASIC, API_KEY and OAUTH2 are supported. This field is functional but is deprecated - authentication for new webhooks should be supplied in the 'authenticationMethods' field.

Enum"API_KEY""BASIC""OAUTH2""MTLS""AD_OAUTH2_CERT"
authenticationMethodsArray of objects(WebhookAuthenticationMethod)

A list of authentication methods. Each authentication method consists of 'type' and 'parameters' fields. Typically only one form of authentication is used, though it is possible to have two API keys or both an API key and OAuth2 authentication.

configNamestring

A unique name used to identify the push configuration.

idinteger(int64)

A unique identifier of the push configuration. Assigned by the push configuration API service and used for updates only.

methodstring

The HTTP method associated with the webhook endpoint. If not provided, will default to POST.

Enum"GET""POST""PUT""PATCH"
methodHeadersobject

A map of optional headers to pass to the webhook.

methodParamsobject

A map of optional method parameters. If provided, these will appear as query parameters on the URL.

payloadFormatstring

The format of the payload to send to the webhook. JSON is the only format supported.

Value"JSON"
urlstring

The URL of the webhook endpoint.

versioninteger(int64)

An optional version of the push configuration.

curl -i -X PUT \
  https://na12.api.project44.com/api/v4/webhooks \
  -H 'Authorization: Bearer <YOUR_TOKEN_HERE>' \
  -H 'Content-Type: application/json' \
  -d '{
    "authParams": {},
    "authType": "API_KEY",
    "authenticationMethods": [
      {
        "parameters": {},
        "type": "API_KEY"
      }
    ],
    "configName": "string",
    "id": 0,
    "method": "GET",
    "methodHeaders": {
      "property1": "string",
      "property2": "string"
    },
    "methodParams": {},
    "payloadFormat": "JSON",
    "url": "string",
    "version": 0
  }'

Responses

OK

Body
authParamsobject

(Deprecated) The webhookAuthenticationMethod parameters. The subordinate fields for the 'authParams' field depend on the authType. This field is functional but is deprecated - authentication for new webhooks should be supplied in the 'authenticationMethods' field.

authTypestring

(Deprecated) The webhookAuthenticationMethod type. BASIC, API_KEY and OAUTH2 are supported. This field is functional but is deprecated - authentication for new webhooks should be supplied in the 'authenticationMethods' field.

Enum"API_KEY""BASIC""OAUTH2""MTLS""AD_OAUTH2_CERT"
authenticationMethodsArray of objects(WebhookAuthenticationMethod)

A list of authentication methods. Each authentication method consists of 'type' and 'parameters' fields. Typically only one form of authentication is used, though it is possible to have two API keys or both an API key and OAuth2 authentication.

configNamestring

A unique name used to identify the push configuration.

idinteger(int64)

A unique identifier of the push configuration. Assigned by the push configuration API service and used for updates only.

methodstring

The HTTP method associated with the webhook endpoint. If not provided, will default to POST.

Enum"GET""POST""PUT""PATCH"
methodHeadersobject

A map of optional headers to pass to the webhook.

methodParamsobject

A map of optional method parameters. If provided, these will appear as query parameters on the URL.

payloadFormatstring

The format of the payload to send to the webhook. JSON is the only format supported.

Value"JSON"
urlstring

The URL of the webhook endpoint.

versioninteger(int64)

An optional version of the push configuration.

Response
{ "authParams": {}, "authType": "API_KEY", "authenticationMethods": [ {} ], "configName": "string", "id": 0, "method": "GET", "methodHeaders": { "property1": "string", "property2": "string" }, "methodParams": {}, "payloadFormat": "JSON", "url": "string", "version": 0 }

Delete a push configuration.

Request

Delete a push configuration.

Path
webhookIdinteger(int64)required

webhookId

curl -i -X DELETE \
  'https://na12.api.project44.com/api/v4/webhooks/{webhookId}' \
  -H 'Authorization: Bearer <YOUR_TOKEN_HERE>'

Responses

OK

Body
Response
{ "errorMessage": "string", "errors": [ {} ], "httpStatusCode": 0, "httpMessage": "string", "supportReferenceId": "string" }

Retrieve a push configuration by id.

Request

Retrieve a push configuration by id.

Path
webhookIdinteger(int64)required

webhookId

curl -i -X GET \
  'https://na12.api.project44.com/api/v4/webhooks/{webhookId}' \
  -H 'Authorization: Bearer <YOUR_TOKEN_HERE>'

Responses

OK

Body
authParamsobject

(Deprecated) The webhookAuthenticationMethod parameters. The subordinate fields for the 'authParams' field depend on the authType. This field is functional but is deprecated - authentication for new webhooks should be supplied in the 'authenticationMethods' field.

authTypestring

(Deprecated) The webhookAuthenticationMethod type. BASIC, API_KEY and OAUTH2 are supported. This field is functional but is deprecated - authentication for new webhooks should be supplied in the 'authenticationMethods' field.

Enum"API_KEY""BASIC""OAUTH2""MTLS""AD_OAUTH2_CERT"
authenticationMethodsArray of objects(WebhookAuthenticationMethod)

A list of authentication methods. Each authentication method consists of 'type' and 'parameters' fields. Typically only one form of authentication is used, though it is possible to have two API keys or both an API key and OAuth2 authentication.

configNamestring

A unique name used to identify the push configuration.

idinteger(int64)

A unique identifier of the push configuration. Assigned by the push configuration API service and used for updates only.

methodstring

The HTTP method associated with the webhook endpoint. If not provided, will default to POST.

Enum"GET""POST""PUT""PATCH"
methodHeadersobject

A map of optional headers to pass to the webhook.

methodParamsobject

A map of optional method parameters. If provided, these will appear as query parameters on the URL.

payloadFormatstring

The format of the payload to send to the webhook. JSON is the only format supported.

Value"JSON"
urlstring

The URL of the webhook endpoint.

versioninteger(int64)

An optional version of the push configuration.

Response
{ "authParams": {}, "authType": "API_KEY", "authenticationMethods": [ {} ], "configName": "string", "id": 0, "method": "GET", "methodHeaders": { "property1": "string", "property2": "string" }, "methodParams": {}, "payloadFormat": "JSON", "url": "string", "version": 0 }

Retrieve a push configuration by name.

Request

Retrieve a push configuration by name.

Path
webhookNamestringrequired

webhookName

curl -i -X GET \
  'https://na12.api.project44.com/api/v4/webhooks/name/{webhookName}' \
  -H 'Authorization: Bearer <YOUR_TOKEN_HERE>'

Responses

OK

Body
authParamsobject

(Deprecated) The webhookAuthenticationMethod parameters. The subordinate fields for the 'authParams' field depend on the authType. This field is functional but is deprecated - authentication for new webhooks should be supplied in the 'authenticationMethods' field.

authTypestring

(Deprecated) The webhookAuthenticationMethod type. BASIC, API_KEY and OAUTH2 are supported. This field is functional but is deprecated - authentication for new webhooks should be supplied in the 'authenticationMethods' field.

Enum"API_KEY""BASIC""OAUTH2""MTLS""AD_OAUTH2_CERT"
authenticationMethodsArray of objects(WebhookAuthenticationMethod)

A list of authentication methods. Each authentication method consists of 'type' and 'parameters' fields. Typically only one form of authentication is used, though it is possible to have two API keys or both an API key and OAuth2 authentication.

configNamestring

A unique name used to identify the push configuration.

idinteger(int64)

A unique identifier of the push configuration. Assigned by the push configuration API service and used for updates only.

methodstring

The HTTP method associated with the webhook endpoint. If not provided, will default to POST.

Enum"GET""POST""PUT""PATCH"
methodHeadersobject

A map of optional headers to pass to the webhook.

methodParamsobject

A map of optional method parameters. If provided, these will appear as query parameters on the URL.

payloadFormatstring

The format of the payload to send to the webhook. JSON is the only format supported.

Value"JSON"
urlstring

The URL of the webhook endpoint.

versioninteger(int64)

An optional version of the push configuration.

Response
{ "authParams": {}, "authType": "API_KEY", "authenticationMethods": [ {} ], "configName": "string", "id": 0, "method": "GET", "methodHeaders": { "property1": "string", "property2": "string" }, "methodParams": {}, "payloadFormat": "JSON", "url": "string", "version": 0 }

Shipment Webhook Data

Operations to describe the payload expected from project44 when integrated with a webhook for shipments.

Operations

Inventory Order and Load Webhook Data

Operations to describe the payload expected from project44 when integrated with a webhook for orders and loads.

Operations

Capacity Provider Metadata

...

Operations

Capacity Provider Contact Management

...

Operations

Capacity Provider Account Management

...

Operations

Capacity Provider Account Group Management

...

Operations

LTL: Push Tracking

...

Operations

LTL: Push Imaging

...

Operations

TL: Capacity Provider Push

...

Operations

Parcel: Push Tracking

...

Operations

Universal Push: Truckload

...

Operations

Push Updates

...

Operations

Analytics: Port Intelligence

...

Operations

Stop Location Management

...

Operations

Postal Address Validation

...

Operations

Appointments

Create, reschedule, cancel, fetch appointments in Yard Management Systems(YMS)

Operations

Capacity

Get capacity for a YMS site within the specified time range

Operations

Milestones

Update yard milestones for a shipment

Operations

Reason Codes

Retrieve all reason codes for the specified YMS site

Operations

Site Codes

Retrieve all sites for the specified YMS tenant

Operations

Slots

Get available slots for a shipment in Yard Management Systems(YMS)

Operations

Invitations

...

Operations

Ocean: Point-to-Point Schedules

...

Operations

LTL: Tracking

...

Operations

TL: Tracking

...

Operations

TL: Webhook

...

Operations

Parcel: Tracking

...

Operations

Parcel: Webhook

...

Operations

Rail: Tracking

...

Operations

Ocean: Tracking

...

Operations